# Changelog

All notable changes to this project will be documented in this file.

The format is based on [Keep a Changelog](http://keepachangelog.com/)

## Releases
> Please note that there are two types of DrugPrep release.  
> * Development releases are intended for use by those involved in actively developing the code (contain the test suite).
> * User releases are intended for users of the code; these do not contain the test suite.
> __Only user releases will be made citeable by deposit on zenodo.org__


## [2.0.0] - 2018-07-13
### Added
-	License file added. 
-	Support for the new common_dosage file format (dosageid(str)/dosage_text) as well as the old format (textid(num)/text). 

### Changed
-	Copyright statements modified to change copyright holder from University of Manchester to Arthritis Research UK Centre for Epidemiology, University of Manchester.  
-	CITATION.md updated to instruct users to refer to latest information on Zenodo page and associated paper(s). 

### Removed
-	“Rights Reserved” removed from in-code copyright statement. 
-	SHARING.md file removed (redistribution covered by license and/copyright). 

### Fixed
-	[Bug #76] Fixed a reproducibility issue (small differences in output files due to arbitrary selection of duplicates to drop) caused by duplicates drop force in line 20 of 1_pre_drugprep.do.



## [1.0.1] - 31/03/2017 (User Release) 

This release is identical to v.1.0.0 except for metadata edits required for archiving on Zenodo. 
Note: this release lives on the zenodo branch

### Changes
* /docs/images removed
* ROADMAP.md removed
* /.github/ .gitignore and .gitattributes removed
* /tests the test suite has been removed.  

## [1.0.0] - 31/03/2017 (Development Release)

### Fixed
* A capitalisation mismatch between a script name and the code prevented DrugPrep being run in Linux; all file paths are now lower case.

### Added
* A suite of tests (test.do) have been added so that developers can establish whether their changes to the code affect the data outputted by DrugPrep (uses synthetic data).
* Support for choosing median and modal values, not just the mean has been added to node 1 (handle implausible qty of things prescribed ), node 2 (handle missing qty of things prescribed ), node 3 (handle implausible ndd  - number of things taken per day) and node 4 (handle missing ndd (number of things taken per day)).
* Informative variable labels have been added and extraneous variables have been removed from the output data set.
*  Support for choosing  GP practice-level averages has been added to nodes 1-4.   
* Additional documentation (ROADMAP and CHANGELOG files).
* .gitattributes file has been added  to configure the way Git manages line endings for all users. 
* Issue and pull request templates have been created and placed in .github.
* CITATION.md file has updated to reflect the fact that code may be obtained via GitHub or Zenodo.

### Changed 
* CONTRIBUTING.md has been moved to a hidden folder .github.
* Node 9 has been modified so that the sort order of the input data is preserved, rather than altered

## [0.1.0] - 28/09/2016

This is the version of the DrugPrep Algorithm shared and evaluated at the  Cross-Farr Drug Data Preparation Workshop (28th September 2016).
