* Copyright (c) Arthritis Research UK Centre for Epidemiology, University of Manchester (2016-2018)
*This do file runs the DrugPrep algorithm going through the 10 decisions in turn


args dec1 dec2  dec3  dec4  dec5  dec6  dec7  dec8 dec9 dec10

	// Verify that decisions are feasible
	local poss1  "1a 1b 1c1 1c2 1c3 1d1 1d2 1d3 1e1 1e2 1e3 1f1 1f2 1f3 1g1 1g2 1g3 "
	local poss2  "2a 2b1 2b2 2b3 2c1 2c2 2c3 2d1 2d2 2d3 2e1 2e2 2e3 2f1 2f2 2f3 "
	local poss3  "3a 3b 3c1 3c2 3c3 3d1 3d2 3d3 3e1 3e2 3e3 3f1 3f2 3f3 3g1 3g2 3g3 "
	local poss4  "4a 4b1 4b2 4b3 4c1 4c2 4c3 4d1 4d2 4d3 4e1 4e2 4e3 4f1 4f2 4f3 "
	local poss5  "5a 5b_6 5b_12 5b_24 5c_6 5c_12 5c_24 "
	local poss6  "6a 6b 6c 6d_15 6d_30 6d_60 6d_90 6e "
	local poss7  "7a 7b 7c 7d "
	local poss8  "8a 8b 8c 8d 8e 8f 8g "
	local poss9  "9a 9b "
	local poss10 "10a 10b_15 10b_30 10b_60 "
	 

	foreach num of numlist 1/10 {
		di as text "Decision `num' = " as result "`dec`num''"
		local found = strpos("`poss`num''", "`dec`num'' ") 
	  if `found' == 0 {
		noi di as error "Invalid option for decision `num': `dec`num''"
		exit
	}
}

	

use "$datadir/pre_drugprep_out.dta", clear

*set implausible values:
do "$dodir/3_drugprep_scripts/dec0_set_implausible_values.do"

*run all the decision nodes	
do "$dodir/3_drugprep_scripts/dec1_implausible_qty.do"       					`dec1'
do "$dodir/3_drugprep_scripts/dec2_missing_qty.do"           					`dec2'
do "$dodir/3_drugprep_scripts/dec3_implausible_ndd.do"       					`dec3'
do "$dodir/3_drugprep_scripts/dec4_missing_ndd.do"           					`dec4'
do "$dodir/3_drugprep_scripts/dec5_clean_duration.do"        					`dec5'
do "$dodir/3_drugprep_scripts/dec6_select_stop_date.do"      					`dec6'
do "$dodir/3_drugprep_scripts/dec7_missing_stop_dates.do"    					`dec7'
do "$dodir/3_drugprep_scripts/dec8_multiple_prescriptions_on_same_day_with_diff_stop_date.do"   `dec8'
do "$dodir/3_drugprep_scripts/dec9_overlapping_prescriptions.do"         			`dec9'
do "$dodir/3_drugprep_scripts/dec10_gaps_between_prescriptions.do"        			`dec10'

	
notes : "Prepared with options `dec1' `dec2' `dec3' `dec4' `dec5' `dec6' `dec7' `dec8' `dec9' `dec10'
  
save "$savedir/post_drugprep_out", replace
				  


	
