* Copyright (c) Arthritis Research UK Centre for Epidemiology, University of Manchester (2016-2018)
*This do file handles decision 10 of the DrugPrep algorithm: 
 

// dec10: Handle sequential prescriptions with short gaps
// options are	10a	Do nothing
//			change stop date of first prescription to start date of next if gap is <=
///			10b_15  15 days
///			10b_30  30 days
///			10b_60  60 days			

 
// Maintained by Ruth Costello, 2016-08-19

args dec10

	// Decision 10: What to do about short gaps between prescriptions
	drop if real_stop == start
	sort patid prodcode start
	by patid prodcode: gen gap_to_next = start[_n+1] - real_stop

	if "`dec10'" == "10a" {
		// Do nothing: ignore short gaps
	}
	else {
		if "`dec10'" == "10b_15" {
			local gtn = 15
		}	
		else if "`dec10'" == "10b_30" {
			local gtn = 30
		}
		else if "`dec10'" == "10b_60" {
			local gtn = 60
		}
		if "`dec10'" == "10b_15" | "`dec10'" == "10b_30" | "`dec10'" == "10b_60" {
			replace real_stop = start[_n+1] if gap_to_next <= `gtn'
      replace gap_to_next = . if gap_to_next > `gtn'
		}		
	}

	replace real_duration = real_stop - start
	label variable gap_to_next "Time by which this interval has been extended to avoid gap in exposure."
