  // Copyright (c) Arthritis Research UK Centre for Epidemiology, University of Manchester (2016-2018)
  // This do file handles decision 2 of the DrugPrep algorithm: 
 
 
  // Handle missing qty (total number of things prescribed)
  // options are  2a  Leave as missing (implicitly drop this prescription)
  //              2b1  set to mean for individual's prescriptions for that drug
  //              2b2  set to mean for practice's prescriptions for that drug
  //              2b3  set to mean for populations's prescriptions for that drug
  //              2c1  set to median for individual's prescriptions for that drug
  //              2c2  set to median for practice's prescriptions for that drug
  //              2c3  set to median for population's prescriptions for that drug
  //              2d1  set to mode for individual's prescriptions for that drug
  //              2d2  set to mode for practice's prescriptions for that drug
  //              2d3  set to mode for population's prescriptions for that drug
  //              2e1  use value of individual's next prescription
  //              2e2  use value of practice's next prescription
  //              2e3  use value of population's next prescription
  //              2f1  use value of individual's previous prescription
  //              2f2  use value of practice's previous prescription  
  //              2f3  use value of population's previous prescription
 

  // Maintained Ruth Costello, 2016-08-19

  args dec2 

  local mainopt = substr("`dec2'", 1, 2)
  local subopt = substr("`dec2'", 3, 1)

  if "`subopt'" == "1" {
    local sorter patid
  }
  else if "`subopt'" == "2" {
    local sorter pracid
  }
  else if "`subopt'" == "3" {
    local sorter 
  }

	if "`dec2'" == "2a" {
		// do nothing 
	}
  else if "`mainopt'" == "2b" {
    sort `sorter' prodcode 
    by `sorter' prodcode: egen mean_qty = mean(qty)
    replace qty = mean_qty if qty >= .
  }
  else if "`mainopt'" == "2c" {
    sort `sorter' prodcode
    by `sorter' prodcode: egen mean_qty = median(qty)
    replace qty = mean_qty if qty >= .
  }
  else if "`mainopt'" == "2d" {
    sort `sorter' prodcode
    by `sorter' prodcode: egen mean_qty = mode(qty), maxmode
    replace qty = mean_qty if qty >= .
  }
  else if "`mainopt'" == "2e" {
    sort `sorter' prodcode date presc_id
    by `sorter' prodcode: replace qty = qty[_n-1] if qty >= .
  }
  else if "`mainopt'" == "2f" {
    gsort `sorter' prodcode -date presc_id
    by `sorter' prodcode: replace qty = qty[_n-1] if qty >= .
  }
  	
  capture drop mean_qty
