  // Copyright (c) Arthritis Research UK Centre for Epidemiology, University of Manchester (2016-2018)
  // This do file handles decision 4 of the DrugPrep algorithm: 
 
 
  // Handle missing ndd (number of things taken per day)
  // options are  4a  Leave as missing (implicitly drop this prescription)
  //              4b1  set to mean for individual's prescriptions for that drug
  //              4b2  set to mean for practice's prescriptions for that drug
  //              4b3  set to mean for populations's prescriptions for that drug
  //              4c1  set to median for individual's prescriptions for that drug
  //              4c2  set to median for practice's prescriptions for that drug
  //              4c3  set to median for population's prescriptions for that drug
  //              4d1  set to mode for individual's prescriptions for that drug
  //              4d2  set to mode for practice's prescriptions for that drug
  //              4d3  set to mode for population's prescriptions for that drug
  //              4e1  use value of individual's next prescription
  //              4e2  use value of practice's next prescription
  //              4e3  use value of population's next prescription
  //              4f1  use value of individual's previous prescription
  //              4f2  use value of practice's previous prescription  
  //              4f3  use value of population's previous prescription
 
  // Maintained by Ruth Costello, 2016-08-19 

  args dec4

  local mainopt = substr("`dec4'", 1, 2)
  local subopt = substr("`dec4'", 3, 1)

  if "`subopt'" == "1" {
    local sorter patid
  }
  else if "`subopt'" == "2" {
    local sorter pracid
  }
  else if "`subopt'" == "3" {
    local sorter 
  }

	if "`dec4'" == "4a" {
		// do nothing 
	}
  else if "`mainopt'" == "4b" {
    sort `sorter' prodcode 
    by `sorter' prodcode: egen mean_ndd = mean(ndd)
    replace ndd = mean_ndd if ndd >= .
  }
  else if "`mainopt'" == "4c" {
    sort `sorter' prodcode
    by `sorter' prodcode: egen mean_ndd = median(ndd)
    replace ndd = mean_ndd if ndd >= .
  }
  else if "`mainopt'" == "4d" {
    sort `sorter' prodcode
    by `sorter' prodcode: egen mean_ndd = mode(ndd), maxmode
    replace ndd = mean_ndd if ndd >= .
  }
  else if "`mainopt'" == "4e" {
    sort `sorter' prodcode date presc_id
    by `sorter' prodcode: replace ndd = ndd[_n-1] if ndd >= .
  }
  else if "`mainopt'" == "4f" {
    gsort `sorter' prodcode -date presc_id
    by `sorter' prodcode: replace ndd = ndd[_n-1] if ndd >= .
  }

  capture drop mean_ndd	
	
  
