* Copyright (c) Arthritis Research UK Centre for Epidemiology, University of Manchester (2016-2018)
*This do file handles decision 7 of the DrugPrep algorithm: 
 
// dec7: Handle missing stop dates
// options are	7a	Leave as missing, drop prescription
//		7b	Use mean for that drug for that individual
//		7c	Use mean for that drug for all individuals
//		7d 	Use individual mean for that drug but if not available use population mean
	 

// Maintained by Ruth Costello, 2016-08-19

args dec7

// Decision 7: replacing missing real_stops
	if "`dec7'" == "7a" {
		drop if real_duration == .
	}
	else if "`dec7'" == "7b" {
		sort patid prodcode
		by patid prodcode: egen mean_dur = mean(real_duration)
		replace real_duration  = floor(mean_dur) if real_duration == .
		replace real_stop = start + real_duration if real_stop == .
		// Still drop those for which no duration could be calculated
		drop if real_duration == .
	}
	else if "`dec7'" == "7c" {
		sort prodcode
		by prodcode: egen mean_dur = mean(real_duration)
		replace real_duration  = floor(mean_dur) if real_duration == .
		replace real_stop = start + real_duration if real_stop == .
		// Still drop those for which no duration could be calculated
		drop if real_duration == .
	}
	else if "`dec7'" == "7d" {
		sort prodcode patid
		by prodcode patid: egen imean_dur = mean(real_duration)
		by prodcode: egen mean_dur = mean(real_duration)
		replace real_duration  = floor(imean_dur) if real_duration == .
		replace real_duration  = floor(mean_dur)  if real_duration == .
		replace real_stop = start + real_duration if real_stop == .
		// Still drop those for which no duration could be calculated
		drop if real_duration == .
	}
	
capture drop mean_dur
capture drop imean_dur
	


